#ifndef QWORDCOMPLETER_H
#define QWORDCOMPLETER_H

#include <QCompleter>

/*
 * Пользовательский класс автозаполнителя
 * реализует автозаполнение по ключевым словам в виджетах QTextEdit и наследниках
 */
class QWordCompleter : public QCompleter
{
  Q_OBJECT
public:
  QWordCompleter(const QStringList& completions, QObject *parent = 0);
  ~QWordCompleter();
public:
  //метод перехвата событий текстового виджета
  virtual bool eventFilter(QObject *o, QEvent *e);

  //параметр определяет начиная с какой длины слова можно использовать автозаполнитель
  int getMinCompletionPrefixLength() const;
  void setMinCompletionPrefixLength(int value);
public slots:
  //подменяет текущее слово в тексте строкой аргумента
  //(вынесен в отдельный слот для того, чтобы можно было использовать и другую логику автозаполнения)
  void replaceCurrentWord(QString text);

private:  
  int minCompletionPrefixLength = 1;
};

#endif // QWORDCOMPLETER_H
